SystemOrganization addCategory: #ARAP!

Morph subclass: #PointEditorMorph
	instanceVariableNames: 'origForm vertices button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ARAP'!

!PointEditorMorph class methodsFor: 'as yet unclassified' stamp: 'yo 1/18/2017 10:46'!
fileNamed: aFileName
	^ self new initializeFor: (ImageReadWriter formFromFileNamed: aFileName).! !

!PointEditorMorph methodsFor: 'as yet unclassified' stamp: 'yo 1/13/2017 15:04'!
drawOn: aCanvas

	aCanvas drawImage: origForm at: bounds origin.
	1 to: vertices size - 1 do: [:i |
		aCanvas line: (vertices at: i) + bounds origin to: (vertices at: i + 1)  + bounds origin width: 1 color: Color blue].
	vertices do: [:v |
		aCanvas fillOval: ((v + bounds origin extent: 0@0) expandBy: 2@2) color: Color red].
! !

!PointEditorMorph methodsFor: 'as yet unclassified' stamp: 'yo 1/13/2017 14:02'!
handlesMouseDown: evt

	^ true
! !

!PointEditorMorph methodsFor: 'as yet unclassified' stamp: 'yo 1/18/2017 12:08'!
initializeFor: aForm
	vertices := OrderedCollection new.
	origForm := aForm.
	self extent: origForm extent.
	button := SimpleButtonMorph new.
	self addMorphFront: button.
	button position: self position.
	button target: self.
	button actionSelector: #write.
	button labelString: 'Write'.
! !

!PointEditorMorph methodsFor: 'as yet unclassified' stamp: 'yo 1/13/2017 14:28'!
mouseDown: evt

	| p |
	p := evt position - bounds origin.
	Transcript show: p printString; cr.
	vertices addLast: p.
	self changed.! !

!PointEditorMorph methodsFor: 'as yet unclassified' stamp: 'yo 1/18/2017 11:24'!
verticesOn: aStream
	vertices do: [:v |
		aStream nextPutAll: v printString; lf]! !

!PointEditorMorph methodsFor: 'as yet unclassified' stamp: 'yo 1/18/2017 11:11'!
write
	| stream |
	stream := FileStream newFileNamed: 'points'.
	self verticesOn: stream.
	stream close.
! !

Morph subclass: #ShapeViewer
	instanceVariableNames: 'vertices edges neighbors highlightedEdge highlightedVertex handles button'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ARAP'!

!ShapeViewer class methodsFor: 'as yet unclassified' stamp: 'yo 1/13/2017 15:01'!
vertices: vertices edges: edges

	^ self new vertices: vertices edges: edges
! !

!ShapeViewer class methodsFor: 'as yet unclassified' stamp: 'yo 1/13/2017 16:50'!
vertices: vertices edges: edges neighbors: neighbors

	^ self new vertices: vertices edges: edges neighbors: neighbors! !

!ShapeViewer methodsFor: 'as yet unclassified' stamp: 'yo 1/20/2017 11:00'!
drawOn: aCanvas

	| v1 v2 quad p e1 |
	aCanvas fillRectangle: bounds color: Color white.
	edges do: [:e |
		v1 := vertices at: e first.
		v2 := vertices at: e second.
		aCanvas line: v1 + bounds origin to: v2  + bounds origin width: 1 color: Color blue].
	vertices do: [:v |
		aCanvas fillOval: ((v + bounds origin extent: 0@0) expandBy: 2@2) color: Color red].
	
	(highlightedEdge notNil and: [neighbors notNil]) ifTrue: [
		quad := neighbors at: highlightedEdge.
		v1 := vertices at: quad first.
		v2 := vertices at: quad second.
		aCanvas line: v1 + bounds origin to: v2  + bounds origin width: 3 color: Color blue.
		
		e1 := Point r: 8 degrees: ((v2 - v1) theta + 2.6) radiansToDegrees.
		aCanvas line: v2 + bounds origin to: v2  + bounds origin + e1 width: 3 color: Color blue.
		e1 := Point r: 8 degrees: ((v2 - v1) theta - 2.6) radiansToDegrees.
		aCanvas line: v2 + bounds origin to: v2  + bounds origin + e1 width: 3 color: Color blue.

		quad third ~= 0 ifTrue: [
			p := vertices at: quad third.
			aCanvas fillOval: ((p + bounds origin extent: 0@0) expandBy: 4@4) color: Color green].
		quad fourth ~= 0 ifTrue: [
			p := vertices at: quad fourth.
			aCanvas fillOval: ((p + bounds origin extent: 0@0) expandBy: 4@4) color: Color magenta]].

	highlightedVertex notNil ifTrue: [
		aCanvas fillOval: (((vertices at: highlightedVertex) + bounds origin extent: 0@0) expandBy: 2@2) color: Color yellow].

! !

!ShapeViewer methodsFor: 'as yet unclassified' stamp: 'yo 1/20/2017 10:39'!
handlesMouseDown: evt
	^ true! !

!ShapeViewer methodsFor: 'as yet unclassified' stamp: 'yo 1/13/2017 16:11'!
handlesMouseMove: evt
	^ true! !

!ShapeViewer methodsFor: 'as yet unclassified' stamp: 'yo 1/13/2017 16:44'!
isClose: p to: v1 and: v2
	| v t max min |
	v := v2 - v1.
	v = (0@0) ifTrue: [^ false].
	t := p - v1.
	t = (0@0) ifTrue: [^ false].
	v x = 0 ifTrue: [
		^ t x = 0 and: [(t y / v y asFloat) between: 0.0 and: 1.0]].
	min := v1 x min: v2 x.
	max := v1 x max: v2 x.
	^ (p x between: min and: max) and: [((v y * (t x  / v x asFloat)) -  t y) abs < 12]
! !

!ShapeViewer methodsFor: 'as yet unclassified' stamp: 'yo 1/20/2017 10:47'!
mouseDown: evt
	| p vert |
	(super containsPoint: evt position) ifFalse: [^ self].
	p := evt position - bounds origin.
	1 to: vertices size do: [:i |
		vert := vertices at: i.
		((vert - p) r < 8) ifTrue: [
			handles add: i]].
! !

!ShapeViewer methodsFor: 'as yet unclassified' stamp: 'yo 1/20/2017 11:00'!
mouseMove: evt
	| p v1 v2 pair vert |
	(super containsPoint: evt position) ifFalse: [^ self].
	p := evt position - bounds origin.
	highlightedEdge := nil.
	highlightedVertex := nil.
	1 to: edges size do: [:i |
		pair := edges at: i.
		v1 := vertices at: pair first.
		v2 := vertices at: pair second.
		(self isClose: p to: v1 and: v2) ifTrue: [
			highlightedEdge := i]].

	1 to: vertices size do: [:i |
		vert := vertices at: i.
		((vert - p) r < 8) ifTrue: [
			highlightedVertex := i]].

	self changed.! !

!ShapeViewer methodsFor: 'as yet unclassified' stamp: 'yo 1/20/2017 11:05'!
showHandles
	FillInTheBlank request: 'handles' initialAnswer: handles asSortedCollection asArray printString. 
	
	
! !

!ShapeViewer methodsFor: 'as yet unclassified' stamp: 'yo 1/13/2017 15:34'!
vertices: vs edges: es
	self vertices: vs edges: es neighbors: nil
! !

!ShapeViewer methodsFor: 'as yet unclassified' stamp: 'yo 1/20/2017 11:07'!
vertices: vs edges: es neighbors: ns
	| min |
	vertices := vs.
	edges := es.
	neighbors := ns.

	min := vertices min.
	self extent: ((Rectangle encompassing: vs) extent + (40@40) + min).
	handles := OrderedCollection new.
	button := SimpleButtonMorph new.
	self addMorphFront: button.
	button position: self position.
	button target: self.
	button actionSelector: #showHandles.
	button labelString: 'Show Handles'.
! !

Object subclass: #Shape
	instanceVariableNames: 'form vertices edges triangles neighbors handles edgeDiffs a1 bx by ts column hasInput'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ARAP'!

!Shape class methodsFor: 'as yet unclassified' stamp: 'bf 1/26/2017 17:33'!
fileNamed: baseName
	| es ns ts vs form |
	vs := (Compiler evaluate: (FileStream readOnlyFileNamed: './arap-triangulation/', baseName, '.mesh.verts') contentsOfEntireFile)
	        collect: [: pair | pair first @pair second].
	es := Compiler evaluate: (FileStream readOnlyFileNamed: './arap-triangulation/', baseName, '.mesh.edges') contentsOfEntireFile.
	ts := Compiler evaluate: (FileStream readOnlyFileNamed: './arap-triangulation/', baseName, '.mesh.tris') contentsOfEntireFile.
	ns := (Compiler evaluate: (FileStream readOnlyFileNamed: './arap-triangulation/', baseName, '.mesh.neighs') contentsOfEntireFile).
	form := Form fromFileNamed: './arap-triangulation/', baseName, '.gif'.
	^ self new vertices: vs edges: es triangles: ts neighbors: ns; form: form
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 1/20/2017 13:12'!
octopus

	| es ns ts vs |
	vs := (Compiler evaluate: (FileStream readOnlyFileNamed: './arap-triangulation/octopus.mesh.verts') contentsOfEntireFile)
 	       collect: [: pair | pair first @pair second].
	es := Compiler evaluate: (FileStream readOnlyFileNamed: './arap-triangulation/octopus.mesh.edges') contentsOfEntireFile.
	ts := Compiler evaluate: (FileStream readOnlyFileNamed: './arap-triangulation/octopus.mesh.tris') contentsOfEntireFile.
	ns := (Compiler evaluate: (FileStream readOnlyFileNamed: './arap-triangulation/octopus.mesh.neighs') contentsOfEntireFile).

	^ self new vertices: vs edges: es triangles: ts neighbors: ns handles: #().! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 14:19'!
square
	^ self new vertices: self squareVertices edges: self squareEdges triangles: self squareTriangles neighbors: self squareEdgeNeighbors handles: self squareHandles.! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 14:18'!
squareEdgeNeighbors
	^ #((1 2 3 0) (1 3 2 5) (1 5 3 0) (2 3 4 1) (2 4 3 0) (3 4 2 5) (3 5 4 1) (4 5 3 0))

	"^ #((1 2 3 0) (2 3 4 1) (3 1 5 2) (3 4 2 5) (4 2 3 0) (4 5 3 0) (5 3 1 4) (1 5 3 0))"

	"
	^ #((1 2) (2 3) (3 1) (3 4) (4 2) (4 5) (5 3) (1 5)).
	^ #((1 2) (1 3) (1 5) (2 3) (2 4) (3 4) (3 5) (4 5))."
	
"	^ {0@0. 2@0. 1@1. 2@2. 0@2}"! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 14:19'!
squareEdges
	^ #((1 2) (1 3) (1 5) (2 3) (2 4) (3 4) (3 5) (4 5)).
	"^ #((1 2) (2 3) (3 1) (3 4) (4 2) (4 5) (5 3) (1 5))."
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 14:19'!
squareHandles
	^ #(1 3).
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 14:19'!
squareTriangles
	^ #((1 2 3) (1 3 4) (3 2 4) (3 4 5))
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 14:19'!
squareVertices
	^ {10@10. 210@10. 110@110. 210@210. 10@210}
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 14:18'!
star
	^ self new vertices: self starVertices edges: self starEdges triangles: self starTriangles neighbors: self starEdgeNeighbors handles: self starHandles.! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 15:39'!
starEdgeNeighbors
	^ #((1 7 6 0) (7 2 8 0) (2 8 7 0) (8 3 9 0) (3 9 8 0) (9 4 10 0) (4 10 9 0) (10 5 6 0) (5 6 10 0) (6 1 7 0) (7 6 11 1) (8 7 11 2) (9 8 11 3) (10 9 11 4) (6 10 11 5) (6 11 7 10) (7 11 8 6) (8 11 9 7) (9 11 10 8) (10 11 6 9))! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 15:36'!
starEdges
	^ #((1 7) (7 2) (2 8) (8 3) (3 9) (9 4) (4 10) (10 5) (5 6) (6 1) (7 6) (8 7) (9 8) (10 9) (6 10) (6 11) (7 11) (8 11) (9 11) (10 11))
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 10:09'!
starHandles
	^ #(1 8 9  10) "#(1 2 3 4 5)"
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 14:14'!
starTriangles
	^ #((1 6 7) (2 7 8) (3 8 9) (4 9 10) (5 6 10) (6 7 11) (7 8 11) (8 9 11) (9 10 11) (10 6 11))
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/22/2016 15:27'!
starVertices
	^  {250.0@150.0. 345.10565@219.0983. 308.77852@330.90169. 191.22147@330.90169. 154.89434@219.0983. 225.31301@216.02128. 274.68698@216.02128. 289.94437@262.34349. 250.0@292.0. 210.05562@262.34349. 250@250}! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 14:18'!
truss
	^ self new vertices: self trussVertices edges: self trussEdges triangles: self trussTriangles neighbors: self trussEdgeNeighbors handles: self trussHandles.! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 13:37'!
trussEdgeNeighbors
	^ #((1 2 3 0) (2 3 1 5) (3 1 2 4) (2 5 3 0) (5 3 2 4) (3 4 1 5) (1 4 3 0)
		(4 5 6 3) (5 6 4 8) (6 4 5 7) (5 8 6 0) (8 6 5 7) (6 7 4 8) (4 7 6 0)
		(7 8 9 6) (8 9 7 11) (9 7 8 10) (8 11 9 0) (11 9 8 10) (9 10 7 11) (7 10 9 0)
		(10 11 12 9) (11 12 10 14) (12 10 11 13) (11 14 12 0) (14 12 11 13) (12 13 10 14) (10 13 12 0)
		(13 14 15 12) (14 15 13 17) (15 13 14 16) (14 17 15 0) (17 15 14 16) (15 16 13 17) (13 16 15 0)
		(16 17 18 15) (17 18 16 20) (18 16 17 19) (17 20 18 0) (20 18 17 19) (18 19 16 20) (16 19 18 0)
		(19 20 21 18) (20 21 19 0) (21 19 20 0) 
	)! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 13:37'!
trussEdges
	^ #((1 2) (2 3) (3 1) (2 5) (5 3) (3 4) (1 4)
		(4 5) (5 6) (6 4) (5 8) (8 6) (6 7) (4 7)
 		(7 8) (8 9) (9 7) (8 11) (11 9) (9 10) (7 10)
		(10 11) (11 12) (12 10) (11 14) (14 12) (12 13) (10 13)
		(13 14) (14 15) (15 13) (14 17) (17 15) (15 16) (13 16)
		(16 17) (17 18) (18 16) (17 20) (20 18) (18 19) (16 19)
		(19 20) (20 21) (21 19) )

! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 13:46'!
trussHandles
	^ #(1 2 6 12 18 21) "#(1 2 3 4 5)"
! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 14:17'!
trussTriangles
	^ #((1 2 3) (2 3 5) (3 1 4) (3 4 5)
	(4 5 6) (5 6 8) (6 4 7) (6 7 8)
	(7 8 9) (8 9 11) (9 7 10) (9 10 11)
	(10 11 12) (11 12 14) (12 10 13) (12 13 14)
	(13 14 15) (14 15 17) (15 13 16) (15 16 17)
	(16 17 18) (17 18 20) (18 16 19) (18 19 20)
	(19 20 21))! !

!Shape class methodsFor: 'as yet unclassified' stamp: 'yo 8/23/2016 13:37'!
trussVertices
	^  {
	0@0. 0@100. 50@50.
	100@0 . 100@100 . 150@50.
	200@0 . 200@100 . 250@50.
	300@0 . 300@100 . 350@50.
	400@0 . 400@100 . 450@50.
	500@0 . 500@100 . 550@50.
	600@0 . 600@100 . 650@50.
	
} + (20@20)! !

!Shape methodsFor: 'initialization' stamp: 'yo 1/31/2017 16:26'!
a1: mat

	a1 := mat.
	ts := Array new: edges size.
	hasInput := Array new: edges size.

	bx := (1 to: edges size + handles size) collect: [:i | Array new: 1].
	by := (1 to: edges size + handles size) collect: [:i | Array new: 1].

	column := Array new: vertices size * 2.
! !

!Shape methodsFor: 'normalized' stamp: 'yo 1/31/2017 15:58'!
computeT2: i to: input
	| neighbor vi vj vl vr vid vjd vld vrd vds gt |
	neighbor := neighbors at: i.
	vi := (neighbor at: 1).
	vj := (neighbor at: 2)..
	vl := (neighbor at: 3)..
	vr := (neighbor at: 4).
	gt := {
		{(vertices at: vi) x. (vertices at: vi) y. (vertices at: vj) x. (vertices at: vj) y. (vertices at: vl) x. (vertices at: vl) y}.
		{(vertices at: vi) y. ((vertices at: vi) x) negated. (vertices at: vj) y. ((vertices at: vj) x) negated.  (vertices at: vl) y. ((vertices at: vl) x) negated}}.
	vid := input at: vi ifAbsent: [vertices at: vi].
	vjd := input at: vj ifAbsent: [vertices at: vj].
	vld := input at: vl ifAbsent: [vertices at: vl].
	vds := {
		vid x.
		vid y.
		vjd x.
		vjd y.
		vld x.
		vld y}.
	vr > 0 ifTrue: [
		gt := {
			(gt at: 1), {(vertices at: vr) x. (vertices at: vr) y}.
			(gt at: 2), { (vertices at: vr) y. ((vertices at: vr) x) negated}}.
		vrd := input at: vr ifAbsent: [vertices at: vr].
		vds := vds, {
			vrd x.
			vrd y}].
	^ self twoVarLeastSquareFit: gt with: vds.
! !

!Shape methodsFor: 'debugging' stamp: 'yo 8/19/2016 16:22'!
drawRectangle: mat with: input
	| f c |
	self halt.
	f := Form extent: 300@300 depth: 32.
	f fillColor: Color white.
	c := f getCanvas.
	1 to: vertices size do: [:i |
		| p |
		p := (mat at: (i - 1) * 2 + 1)@(mat at: (i - 1) * 2 + 2).
		c fillRectangle: ((p - 8) extent: 16) color: Color black.
	].
	edges do: [:pair | | dest orig |
		orig := (mat at: (pair first - 1) * 2 + 1)@(mat at: (pair first - 1) * 2 + 2).
		dest := (mat at: (pair second - 1) * 2 + 1)@(mat at: (pair second - 1) * 2 + 2).
		c line: orig to: dest width: 2 color: Color gray.
	].
	f displayOn: Display.
! !

!Shape methodsFor: 'accessing' stamp: 'yo 8/22/2016 12:04'!
edges
	^ edges
! !

!Shape methodsFor: 'accessing' stamp: 'bf 1/26/2017 17:36'!
form
	^form! !

!Shape methodsFor: 'initialization' stamp: 'bf 1/26/2017 17:29'!
form: aForm
	form := aForm! !

!Shape methodsFor: 'accessing' stamp: 'yo 8/22/2016 13:52'!
handles
	^ handles
! !

!Shape methodsFor: 'initialization' stamp: 'yo 1/20/2017 11:52'!
handles: hs
	handles := hs.
! !

!Shape methodsFor: 'normalized' stamp: 'yo 1/23/2017 12:24'!
hasInputFor: i in: input
	| neighbor vi vj vl vr |
	(hasInput at: i) ifNil: [
		neighbor := neighbors at: i.
		vi := (neighbor at: 1).
		vj := (neighbor at: 2)..
		vl := (neighbor at: 3)..
		vr := (neighbor at: 4).
		hasInput at: i put: ((input includesKey: vi) or: [.
					 (input includesKey: vj) or: [.
						 (input includesKey: vl) or: [.
						 (input includesKey: vr)]]]).
	].
	^ hasInput at: i.
! !

!Shape methodsFor: 'normalized' stamp: 'yo 1/31/2017 16:17'!
m: m b: b
	| r row v |
	r := Array new: m rowCount.
	1 to: m rowCount do: [:y |
		v := 0.0.
		row := m atRow: y.
		1 to: row size do: [:x |
			v := v + ((row at: x) * ((b at: x) at: 1))].
		r at: y put: v].
	^ r
! !

!Shape methodsFor: 'accessing' stamp: 'yo 1/31/2017 16:32'!
matrixClass
	^ Smalltalk at: #LapackDGEMatrix ifAbsent: [nil].
	"^ nil"! !

!Shape methodsFor: 'normalized' stamp: 'yo 1/31/2017 16:15'!
normalSetupA1: input
	| t ta |
	a1 ifNotNil: [^ self].
	
	self matrixClass ifNil: [^ self].
	a1 := ((1 to: (edges size + handles size)) collect: [:e | FloatArray new: vertices size]).
	self normalSetupA1Top: input.
	self normalSetupA1Bottom: input.

	a1 := self matrixClass rows: a1.
	t := a1 transposed.
	ta := t * a1.
	a1 := (t * a1) solve: t.
	
	ts := Array new: edges size.
	hasInput := Array new: edges size.

	bx := (1 to: edges size + handles size) collect: [:i | Array new: 1].
	by := (1 to: edges size + handles size) collect: [:i | Array new: 1].

	column := Array new: vertices size * 2.

! !

!Shape methodsFor: 'normalized' stamp: 'yo 1/19/2017 11:37'!
normalSetupA1Bottom: input

	1 to: handles size do: [:h |
		| row |
		row := a1 at: edges size + h.
		row at: (handles at: h) put: 1000.
	].
! !

!Shape methodsFor: 'normalized' stamp: 'yo 1/19/2017 11:36'!
normalSetupA1Top: input

	1 to: edges size do: [:e |
		| neighbor vi vj row |
		neighbor := neighbors at: e.
		vi := neighbor at: 1.
		vj := neighbor at: 2.
		row := a1 at: e. "(e - 1) * 2 + 1"

		row at: vi put: -1.
		row at: vj put: 1.
	].
! !

!Shape methodsFor: 'normalized' stamp: 'yo 1/23/2017 12:25'!
normalT2: i to: input
	| p t hasIt |
	hasIt := self hasInputFor: i in: input.
	hasIt ifFalse: [
		t := ts at: i.
		t ifNil: [
			p := self computeT2: i to: input.
			ts at: i put: (p / (p dotProduct: p))].
		^ ts at: i
	] ifTrue: [
		p := self computeT2: i to: input.
		ts at: i put: (p / (p dotProduct: p)).
		^ ts at: i
	].
! !

!Shape methodsFor: 'normalized' stamp: 'yo 1/31/2017 16:17'!
normalizedSolve: input
	| t vx vy cls |
	self normalSetupA1: input.
	1 to: edges size do: [:e |
		t := self normalT2: e to: input.
		(bx at: e) at: 1 put: (t x * (edgeDiffs at: e) x) + (t y * ((edgeDiffs at: e) y)).
		(by at: e) at: 1 put: (t y negated * (edgeDiffs at: e) x) + (t x * ((edgeDiffs at: e) y))].
	1 to: handles size do: [:index |
		| p h |
		h := handles at: index.
		p := input at: h ifAbsent: [vertices at: h].
		(bx at: (edges size + index)) at: 1 put: 1000.0 * p x.
		(by at: (edges size + index)) at: 1 put: 1000.0 * p y].
	cls := self matrixClass.
	cls ifNotNil: [
		vx := a1 * (cls rows: bx).
		vy := a1 * (cls rows: by)]
	ifNil: [
		vx := self m: a1 b: bx.
		vy :=self m: a1 b: by.
	].
	1 to: vx size do: [:index |
		column at: ((index - 1) * 2 + 1) put: (vx at: index).
		column at: ((index - 1) * 2 + 2) put: (vy at: index)].		
	^ column	
! !

!Shape methodsFor: 'initialization' stamp: 'yo 1/31/2017 16:26'!
readMatFile: aFileName
	| stream row col string |
	stream := FileStream readOnlyFileNamed: aFileName.
	row := Number readFrom: stream.
	stream skipSeparators.
	col := Number readFrom: stream.
	string := stream upToEnd.
	stream close.
	self a1: (Matrix rows: row columns: col contents: (Compiler evaluate: string)).
! !

!Shape methodsFor: 'accessing' stamp: 'yo 1/31/2017 16:31'!
reset
	self matrixClass ifNil: [^ self].
	a1 := bx := by := ts := column := hasInput:= nil.
! !

!Shape methodsFor: 'debugging' stamp: 'yo 1/25/2017 10:47'!
saveA1Named: aFileName
	|s array |
	s := FileStream newFileNamed: aFileName.
	s nextPutAll: a1 nrow printString; space; nextPutAll: a1 ncol printString;cr.
	array := a1 transposed asArray.
	s nextPutAll: '#('.
	1 to: array size do: [:i |
		 s nextPutAll: (array at: i) printString; space].
	s nextPutAll: ')'.
	s close.
! !

!Shape methodsFor: 'debugging' stamp: 'yo 1/25/2017 10:39'!
saveTsNamed: aFileName
	| s | 
	s := FileStream newFileNamed: aFileName.
	s nextPutAll: '#('.
	ts do: [:point |
		s nextPutAll: '('; nextPutAll: point x printString; space; nextPutAll: point y printString; nextPutAll: ')'; cr].
	s nextPutAll: ')'..
	s close.
! !

!Shape methodsFor: 'accessing' stamp: 'yo 8/23/2016 14:22'!
triangles
	^ triangles
! !

!Shape methodsFor: 'normalized' stamp: 'yo 1/31/2017 13:45'!
twoVarLeastSquareFit: gt with: vs
	| a b d det inva invb invd c gt1 gt2 gtgg1 gtgg2 s |
	gt1 := gt at: 1.
	gt2 := gt at: 2.
	
	a := (gt1 * gt1) sum.
	b := (gt1 * gt2) sum.
	d := (gt2 * gt2) sum.

	det := 1.0 / ((a * d) - (b * b)).

	inva := det * d.
	invb := det * b negated.
	invd := det * a.
	
	gtgg1 := (gt1 * inva) + (gt2 * invb).
	gtgg2 := (gt1 * invb) + (gt2 * invd).

	c := (gtgg1 * vs) sum.
	s := (gtgg2 * vs) sum.
	^ c@s.
! !

!Shape methodsFor: 'accessing' stamp: 'yo 8/22/2016 12:04'!
vertices
	^ vertices
! !

!Shape methodsFor: 'initialization' stamp: 'yo 1/20/2017 11:52'!
vertices: vs edges: es triangles: ts neighbors: ns
	vertices := vs.
	edges := es.
	triangles := ts.
	neighbors := ns.
	edgeDiffs := edges collect: [:pair | (vertices at: (pair at: 2)) - (vertices at: (pair at: 1))].! !

!Shape methodsFor: 'initialization' stamp: 'yo 1/20/2017 11:52'!
vertices: vs edges: es triangles: ts neighbors: ns handles: hs
	self vertices: vs edges: es triangles: ts neighbors: ns.
	self handles: hs.
! !

Morph subclass: #ARAPMorph
	instanceVariableNames: 'shape inputs dragging column solver fill ziggle showEdges showHandles doZiggle ziggleButton gl tex texCoords display'
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants'
	category: 'ARAP'!

!ARAPMorph class methodsFor: 'instance creation' stamp: 'yo 8/22/2016 12:05'!
newOn: aShape
	^ self new shape: aShape.
! !

!ARAPMorph class methodsFor: 'examples' stamp: 'yo 9/13/2016 10:56'!
truss
	"
	self truss
	"
	(ARAPMorph newOn: Shape truss) fill: Color red lighter; extent: 800@400; openInWorld! !

!ARAPMorph methodsFor: 'drawing' stamp: 'bf 2/3/2017 15:54'!
containsPoint: aPoint
	| local |
	(super containsPoint: aPoint) ifFalse: [^false].
	display ifNil: [^true].
	local := aPoint - self position.
	showHandles == true ifTrue: [
		shape handles do: [:i | | p r |
			p := (column at: (i - 1) * 2 + 1)@(column at: (i - 1) * 2 + 2).
			r := (p - 8) extent: 16.
			(r containsPoint: local) ifTrue: [^true]]].
	^(display isTransparentAt: local) not! !

!ARAPMorph methodsFor: 'gl rendering' stamp: 'bf 1/31/2017 19:39'!
delete
	self destroyGL.
	^super delete! !

!ARAPMorph methodsFor: 'gl rendering' stamp: 'bf 1/31/2017 19:39'!
destroyGL
	gl ifNotNil: [gl destroy. gl := nil].! !

!ARAPMorph methodsFor: 'drawing' stamp: 'bf 2/3/2017 11:15'!
drawOn: aCanvas
	display ifNotNil: [
		self renderGL.
		aCanvas paintImage: display at: bounds origin.
	] ifNil: [super drawOn: aCanvas].
	aCanvas translateBy: self position during: [:c |
		showEdges == true ifTrue: [
			shape edges do: [:pair | | dest orig |
				orig := (column at: (pair first - 1) * 2 + 1)@(column at: (pair first - 1) * 2 + 2).
				dest := (column at: (pair second - 1) * 2 + 1)@(column at: (pair second - 1) * 2 + 2).
				c line: orig to: dest width: 2 color: Color gray]].
		showHandles == true ifTrue: [
			1 to: shape vertices size do: [:i |
				| p |
				(shape handles includes: i) ifTrue: [
					p := (column at: (i - 1) * 2 + 1)@(column at: (i - 1) * 2 + 2).
					c fillRectangle: ((p - 8) extent: 16) color: (Color magenta).]]]].! !

!ARAPMorph methodsFor: 'stepping' stamp: 'yo 9/13/2016 10:19'!
fill: anObject

	fill := anObject.
! !

!ARAPMorph methodsFor: 'events' stamp: 'yo 8/22/2016 13:40'!
handlesMouseDown: evt
	^ true.
! !

!ARAPMorph methodsFor: 'events' stamp: 'yo 8/22/2016 13:40'!
handlesMouseMove: evt
	^ dragging notNil
! !

!ARAPMorph methodsFor: 'events' stamp: 'yo 8/22/2016 13:40'!
handlesMouseUp: evt
	^ dragging notNil
! !

!ARAPMorph methodsFor: 'gl rendering' stamp: 'bf 1/31/2017 19:46'!
initGL
	| b i w h |
	self destroyGL.
	tex := OGLTexture new form: shape form.
	b := shape form boundingBox.
	b := b align: b bottomLeft with: World bottomLeft.
	gl := OpenGL newIn: b.
	gl ifNil: [^self error: 'Unable to create renderer'].
	display := Form extent: b extent depth: 32.
	gl swapBuffers. "make visible"
	texCoords := FloatArray new: shape triangles size * 6.
	i := 1.
	w := 1.0 / shape form width.
	h := 1.0 / shape form height.
	gl glTranslatef: -1.0 with: -1.0 with: 0.0.
	gl glScalef: 2.0 * w with: 2.0 * h with: 0.0.
	shape triangles do:
		[:tri | tri do:
			[:vi | | v |
			v := shape vertices at: vi.
			texCoords at: i put: v x * w. 
			texCoords at: i+1 put: v y * h.
			i := i + 2]].
! !

!ARAPMorph methodsFor: 'events' stamp: 'yo 1/20/2017 11:06'!
mouseDown: evt
	| local dist |
	local := evt cursorPoint - self position.
	inputs keysAndValuesDo: [:k :v |
		dist := v dist: local.
		(v dist: local) < 8 ifTrue: [
			dragging := k.
			self]].
! !

!ARAPMorph methodsFor: 'events' stamp: 'yo 1/20/2017 14:17'!
mouseMove: evt
	| local |
	dragging ifNotNil: [
		local := evt cursorPoint - self position.
		"((inputs at: dragging) - local) r > 4 ifTrue: ["
			self move: dragging to: local
		"]"
	].
! !

!ARAPMorph methodsFor: 'events' stamp: 'yo 8/22/2016 14:06'!
mouseUp: evt
	super mouseUp: evt.
	dragging := nil.
! !

!ARAPMorph methodsFor: 'events' stamp: 'yo 1/20/2017 15:41'!
move: handle to: aPoint
	| old |
	old := inputs at: handle.
	inputs at: handle put: aPoint.
	column := shape perform: solver with: inputs.
	self changed
! !

!ARAPMorph methodsFor: 'gl rendering' stamp: 'bf 1/31/2017 19:31'!
readbackGL
	gl ifNil: [^self].
	display ifNil: [^self].
	display extent = gl extent ifFalse: [display setExtent: gl extent depth: 32].

	gl glReadBuffer: GLBack.
	gl glReadPixels: 0 with: 0 with: display width with: display height with: GLBgra with: GLUnsignedByte with: display bits.
	! !

!ARAPMorph methodsFor: 'gl rendering' stamp: 'bf 2/2/2017 18:36'!
renderGL
	| vertices i |
	gl ifNil: [^self].
	
	gl beginFrame.
	gl glDisable: GLDepthTest.
	gl glDisable: GLLighting.	

	gl glClearColor: 0.0 with: 0.0 with: 0.0 with: 0.0.
	gl glClear: GLColorBufferBit.

	gl glEnable: GLBlend.
	gl glBlendFunc: GLSrcAlpha with: GLOneMinusSrcAlpha.
	gl glColor3f: 1.0 with: 1.0 with: 1.0.
	gl installTexture: tex.		"uploads only in first frame"
	gl enableTexture: tex.

	vertices := FloatArray new: shape triangles size * 6.
	i := 1.
	shape triangles do:
		[:tri | tri do:
			[:vi | | x y |
			x := column at: (vi - 1) * 2 + 1.
			y := column at: (vi - 1) * 2 + 2.
			vertices at: i put: x.
			vertices at: i+1 put: y.
			i := i + 2]].

	gl glVertexPointer: 2 with: GLFloat with: 0 with: vertices.
	gl glTexCoordPointer: 2 with: GLFloat with: 0 with: texCoords.
	gl glEnableClientState: GLVertexArray.
	gl glEnableClientState: GLTextureCoordArray.
   	gl glDrawArrays: GLTriangles with: 0 with: vertices size // 2.
	gl glDisableClientState: GLTextureCoordArray.
	gl glDisableClientState: GLVertexArray.

	gl disableTexture: tex.
	gl endFrame.
	self readbackGL.
	gl swapBuffers. "show on screen"
! !

!ARAPMorph methodsFor: 'initialization' stamp: 'bf 1/27/2017 19:05'!
shape: aShape
	| r |
	shape := aShape.
	inputs := Dictionary new.
	ziggle := Dictionary new.
	r := 3@0.
	shape handles do: [:h |
		inputs at: h put: (shape vertices at: h).
		ziggle at: h put: r.
		r := r rotateBy: 0.3 about: 0@0].
	self color: Color white.
	self extent: shape vertices max + (20@20).
	column := Array streamContents: [:c |
		shape vertices do: [:v |
			c nextPut: v x.
			c nextPut: v y]].
	self solver: #normalizedSolve:.
	showHandles := true.
	fill := nil.
	doZiggle := false.
	ziggleButton := SimpleButtonMorph new.
	self addMorphFront: ziggleButton.
	ziggleButton position: self position.
	ziggleButton target: self.
	ziggleButton actionSelector: #toggleZiggle.
	ziggleButton labelString: 'Toggle Ziggle'.
	self initGL.
! !

!ARAPMorph methodsFor: 'accessing' stamp: 'yo 9/13/2016 10:56'!
showHandles: aBoolean
	showHandles := aBoolean.
! !

!ARAPMorph methodsFor: 'misc' stamp: 'bf 2/2/2017 18:58'!
solvedBounds
	| maxX maxY minX minY |
	minX := maxX := column at: 1.
	minY := maxY := column at: 2.
	3 to: column size by: 2 do:
		[:i | | x y |
		x := column at: i.
		y := column at: i+1.
		x < minX ifTrue: [minX := x] ifFalse: [x > maxX ifTrue: [maxX := x]].
		y < minY ifTrue: [minY := y] ifFalse: [y > maxY ifTrue: [maxY := y]]].
	^minX floor@minY floor corner: maxX ceiling@maxY ceiling! !

!ARAPMorph methodsFor: 'initialization' stamp: 'yo 1/19/2017 13:39'!
solver: aSelector
	solver := aSelector.
	shape reset.
! !

!ARAPMorph methodsFor: 'stepping' stamp: 'yo 1/18/2017 12:07'!
step
	| s c p |
	doZiggle ifFalse: [^ self].
	s := 0.05 sin.
	c := 0.05 cos.
	ziggle keys do: [:k |
		p := ziggle at: k.
		p := (p x * c - (p y * s))@(p x * s + (p y * c)).
		inputs at: k put: ((inputs at: k) + p).
		ziggle at: k put: p].
	column := shape perform: solver with: inputs.
	self changed
! !

!ARAPMorph methodsFor: 'stepping' stamp: 'yo 1/31/2017 16:11'!
stepTime
	^ 0! !

!ARAPMorph methodsFor: 'accessing' stamp: 'yo 1/18/2017 12:09'!
toggleZiggle
	doZiggle := doZiggle not
! !
